(function ($, Drupal) {
  Drupal.behaviors.imageSizesBehavior = {
    attach: function (context, settings) {
      var timeout;
      $(window).on('scroll resize scrollstop', function(){
        init();
      });

      $(window).scroll();
      $.map($('img.image-sizes'),function(ele){
        var parent = $(ele).parent();
        new ResizeSensor(parent, function() {
          parent.find('> img.image-sizes').each(function(){
            if ($(this).visible()) {
              imageSizesSetUrl(this);
            }
          })
        });
      });
    }
  };
  function init() {
    $('img.image-sizes.pre-load').each(function(){
      if ($(this).visible(true)) {
        imageSizesSetUrl(this);
      }
    });
  }
  function imageSizesSetUrl(ele) {
    var width = $(ele).parent().width();
    if (!$(ele).data('image-sizes')) {
      $(ele).data('image-sizes', JSON.parse($(ele).attr('data-src').replace(/\\/g, '')));
    }
    var conf = $(ele).data('image-sizes');
    var newUrl = false;
    var a;
    for ( var a in conf ) {
      newUrl = conf[a];
      if (a >= width) {
        break;
      }
    }
    ele.addEventListener('load', function() {
      $(ele).attr('width', ele.naturalWidth).attr('height', ele.naturalHeight);
      $(this).removeClass('pre-load');
    }, false);
    if (width > a) {
      ele.src = $(ele).attr('data-src-fallback');
      return;
    }
    if (newUrl !== ele.src) {
      ele.src = newUrl;
    }

  }
})(jQuery, Drupal);
